%define libmajor	0
%define libname		%mklibname pcre 2 %{libmajor}
%define pcre2posixmajor	1
%define libnameposix	%mklibname pcre2posix %{pcre2posixmajor}
%define develname	%mklibname -d %{name}

Name:		pcre2
Version:	10.23
Release:	%mkrel 2
Summary:	Perl-compatible regular expression library
Group:		System/Libraries
# the library:                          BSD
# pcre2test (linked to GNU readline):   BSD (linked to GPLv3+)
#Not distributed in binary package
# autotools:                            GPLv3+ with exception
# install-sh:                           MIT
License:	BSD
URL:		http://www.pcre.org/
Source:		ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/%{name}-%{version}.tar.bz2
# Do no set RPATH if libdir is not /usr/lib
Patch0:		pcre2-10.10-Fix-multilib.patch
# Handle memmory allocation failures in pcre2test tool, in upstream after 10.23
Patch1:     pcre2-10.23-Check-malloc-returns-in-pcre2test.patch
# Fix CVE-2017-7186 (a crash when finding a Unicode property for a character
# with a code point greater than 0x10ffff in UTF-32 library while UTF mode is
# disabled), upstream bug #2052, in upstream after 10.23
Patch2:     pcre2-10.23-Fix-32-bit-non-UTF-property-test-crash.patch
# Fix an internal error for a forward reference in a lookbehind with
# PCRE2_ANCHORED, # oss-fuzz bug #865, in upstream after 10.23
Patch3:     pcre2-10.23-Fix-crash-for-forward-reference-in-lookbehind-with-P.patch
# Fix a pcre2test bug for global match with zero terminated subject,
# upstream bug #2063, in upstream after 10.23
Patch4:     pcre2-10.23-Fix-pcre2test-bug-for-global-match-with-zero-termina.patch
# Close serialization file in pcre2test after any error, upstream bug #2074,
# in upstream after 10.23
Patch5:     pcre2-10.23-Close-serialization-file-in-pcre2test-after-any-erro.patch
# Fix a memory leak in pcre2_serialize_decode() when the input is invalid,
# upstream bug #2075, in upsream after 10.23.
Patch6:     pcre2-10.23-Fix-memory-leak-when-deserializing-invalid-data-Bugz.patch
# Fix a potential NULL dereference in pcre2_callout_enumerate() if called with
# a NULL pattern pointer when Unicode support is available, upstream bug #2076,
# in upstream after 10.23
Patch7:     pcre2-10.23-Fix-NULL-deference-if-pcre2_callout_enumerate-is-cal.patch
# 1/2 Fix 32-bit error buffer size bug in pcre2test, upstream bug #2079,
# in upstream after 10.23
Patch8:     pcre2-10.23-Fix-32-bit-error-buffer-size-bug-in-pcre2test-Bugzil.patch
# 2/2 Fix 32-bit error buffer size bug in pcre2test, upstream bug #2079,
# in upstream after 10.23
Patch9:     pcre2-10.23-Previous-patch-was-not-quite-complete.patch
# Fix DFA match for a possessively repeated character class, upstream bug #2086,
# in upstream after 10.23
Patch10:    pcre2-10.23-Fix-misbehaving-DFA-match-for-possessively-repeated-.patch
# Use a memory allocator from the pattern if no context is supplied to
# pcre2_match(), in upsream after 10.23
Patch11:    pcre2-10.23-Fix-bug-introduced-at-10.21-use-memory-allocator-fro.patch
# Fix CVE-2017-7186 in JIT mode (a crash when finding a Unicode property for
# a character with a code point greater than 0x10ffff in UTF-32 library while
# UTF mode is disabled), bug #1434504, upstream bug #2052,
# in upstream after 10.23
Patch12:    pcre2-10.23-Fix-character-type-detection-when-32-bit-and-UCP-are.patch
# Fix an incorrect cast in UTF validation, upstream bug #2090,
# in upstream after 10.23
Patch13:    pcre2-10.23-Correct-an-incorrect-cast.patch

# New libtool to get rid of RPATH and to use distribution autotools
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	coreutils
BuildRequires:	gcc
BuildRequires:	libtool
BuildRequires:	make
BuildRequires:	readline-devel

%description
PCRE2 is a re-working of the original PCRE (Perl-compatible regular
expression) library to provide an entirely new API.

PCRE2 is written in C, and it has its own API. There are three sets of
functions, one for the 8-bit library, which processes strings of bytes, one
for the 16-bit library, which processes strings of 16-bit values, and one for
the 32-bit library, which processes strings of 32-bit values. There are no C++
wrappers.

The distribution does contain a set of C wrapper functions for the 8-bit
library that are based on the POSIX regular expression API (see the pcre2posix
man page). These can be found in a library called libpcre2posix. Note that
this just provides a POSIX calling interface to PCRE2; the regular expressions
themselves still follow Perl syntax and semantics. The POSIX API is
restricted, and does not give full access to all of PCRE2's facilities.

%package -n	%{libname}
Summary:	Perl-compatible regular expression library
Group:		System/Libraries

%description -n	%{libname}
PCRE2 is a re-working of the original PCRE (Perl-compatible regular
expression) library to provide an entirely new API.

%package -n	%{libnameposix}
Summary:	Perl-compatible regular expression library
Group:		System/Libraries

%description -n	%{libnameposix}
This package contains the shared library libpcre2-posix.

%package -n	%{develname}
Summary:	Development files for %{name}
Group:		Development/C
Provides:	%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}
Requires:	%{libnameposix} = %{version}-%{release}
Requires:	gcc

%description -n	%{develname}
Development files (headers, libraries for dynamic linking, documentation)
for %{name}.  The header file for the POSIX-style functions is called
pcre2posix.h.

%package	tools
Summary:	Auxiliary utilities for %{name}
# pcre2test (linked to GNU readline)	BSD (linked to GPLv3+)
License:	BSD and GPLv3+
Group:		Development/Tools

%description	tools
Utilities demonstrating PCRE2 capabilities like pcre2grep or pcre2test.

%prep
%setup -q
%patch0 -p1 -b .multilib
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
# Because of multilib patch
libtoolize --copy --force
autoreconf -vif

%build
%configure2_5x \
    --enable-jit \
    --enable-pcre2grep-jit \
    --disable-bsr-anycrlf \
    --disable-coverage \
    --disable-ebcdic \
    --disable-fuzz-support \
    --disable-never-backslash-C \
    --enable-newline-is-lf \
    --enable-pcre2-8 \
    --enable-pcre2-16 \
    --enable-pcre2-32 \
    --enable-pcre2grep-callout \
    --enable-pcre2grep-jit \
    --disable-pcre2grep-libbz2 \
    --disable-pcre2grep-libz \
    --disable-pcre2test-libedit \
    --enable-pcre2test-libreadline \
    --disable-rebuild-chartables \
    --enable-shared \
    --enable-stack-for-recursion \
    --disable-static \
    --enable-unicode \
    --disable-valgrind
%make

%install
%makeinstall_std
# Get rid of unneeded *.la files
rm -f %{buildroot}%{_libdir}/*.la
# These are handled by %%doc in %%files
rm -rf %{buildroot}%{_docdir}/pcre2

%check
make check VERBOSE=yes

%files -n %{libname}
%{_libdir}/libpcre2-[0-9]*.so.%{libmajor}{,.*}
%{!?_licensedir:%global license %%doc}
%license COPYING LICENCE
%doc AUTHORS ChangeLog NEWS README

%files -n %{libnameposix}
%{_libdir}/libpcre2-posix.so.%{pcre2posixmajor}{,.*}

%files -n %{develname}
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*.h
%{_mandir}/man1/pcre2-config.*
%{_mandir}/man3/*
%{_bindir}/pcre2-config
%doc doc/*.txt doc/html
%doc HACKING ./src/pcre2demo.c

%files tools
%{_bindir}/pcre2grep
%{_bindir}/pcre2test
%{_mandir}/man1/pcre2grep.*
%{_mandir}/man1/pcre2test.*


%changelog
* Tue Apr 25 2017 neoclust <neoclust> 10.23-2.mga6
+ Revision: 1097366
- Add Fedora patches to fix bugs ( including CVE-2017-7186 (mga#20546))

* Thu Feb 16 2017 luigiwalser <luigiwalser> 10.23-1.mga6
+ Revision: 1086377
- 10.23

* Sun Aug 21 2016 wally <wally> 10.22-2.mga6
+ Revision: 1047605
- add pcre2-devel provides to devel pkg

* Wed Aug 10 2016 luigiwalser <luigiwalser> 10.22-1.mga6
+ Revision: 1045327
- 10.22
- remove upstreamed patches
- add libpcre2posix package for pcre2-posix lib

* Fri Jun 10 2016 luigiwalser <luigiwalser> 10.21-3.mga6
+ Revision: 1021014
- add upstream patch to fix race condition in JIT reported by Mozilla

* Sun May 22 2016 luigiwalser <luigiwalser> 10.21-2.mga6
+ Revision: 1017648
- add upstream patch to fix CVE-2016-3191

* Mon Jan 25 2016 luigiwalser <luigiwalser> 10.21-1.mga6
+ Revision: 927218
- use configure2_5x
- 10.21

* Mon Nov 23 2015 ovitters <ovitters> 10.20-3.mga6
+ Revision: 905303
- fix requires

* Mon Nov 23 2015 ovitters <ovitters> 10.20-2.mga6
+ Revision: 905268
- increase release because why not
- fix group
- adapted from fedora

